//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//

package com.tiptimes.service.impl;

import com.tiptimes.dao.IntegralDao;
import com.tiptimes.dao.TeamMessageDao;
import com.tiptimes.model.Integral;
import com.tiptimes.model.TeamMessage;
import com.tiptimes.service.IntegralService;
import com.tiptimes.util.DATEUtil;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class IntegralServiceImpl implements IntegralService {
    @Autowired
    private IntegralDao integralDao;
    @Autowired
    private TeamMessageDao teamMessageDao;

    public IntegralServiceImpl() {
    }

    @Transactional
    public void saveIntegral(int type, String messageID) {
        try {
            switch(type) {
                case 0:
                    if (this.integralDao.getIntegralSpaceSize(messageID) == 0) {
                        this.integralDao.saveIntegralSpace(messageID);
                    }

                    this.integralDao.updateIntegralSpace(messageID, "ok", (String)null, (String)null, (String)null);
                    break;
                case 1:
                    if (this.integralDao.getIntegralSpaceSize(messageID) == 0) {
                        this.integralDao.saveIntegralSpace(messageID);
                    }

                    this.integralDao.updateIntegralSpace(messageID, (String)null, "ok", (String)null, (String)null);
                    break;
                case 2:
                    this.integralDao.updateIntegralSpace(messageID, (String)null, (String)null, "ok", (String)null);
                    break;
                case 3:
                    this.integralDao.updateIntegralSpace(messageID, (String)null, (String)null, (String)null, "ok");
                    break;
                case 4:
                    if (this.integralDao.getIntegralTeamSize(messageID) == 0) {
                        this.integralDao.saveIntegralTeam(messageID);
                    }

                    this.integralDao.updateIntegralTeam(messageID, "ok", (String)null);
                    break;
                case 5:
                    if (this.integralDao.getIntegralTeamSize(messageID) == 0) {
                        this.integralDao.saveIntegralTeam(messageID);
                    }

                    this.integralDao.updateIntegralTeam(messageID, (String)null, "ok");
                    break;
                case 6:
                    if (this.integralDao.getIntegralUserSize(messageID) == 0) {
                        this.integralDao.saveIntegralUser(messageID);
                    }
                    break;
                case 7:
                    if (this.integralDao.getIntegralLoginSize(messageID) == 0) {
                        this.integralDao.saveIntegralLogin(messageID);
                    }
            }
        } catch (Exception var4) {
        }

    }

    public List<Integral> listIntegralByTime(String time) {
        List<Integral> integral_list = this.integralDao.listIntegralByTime(time);
        return integral_list.size() == 0 ? null : integral_list;
    }

    public List<Integral> listIntegralByStartTimeAndStopTime(String startTime, String stopTime) {
        List<Integral> integral_list = this.integralDao.listIntegralByStartTimeAndStopTime(startTime, stopTime);
        return integral_list.size() == 0 ? null : integral_list;
    }

    public List<Integral> listIntegralByStartTimeAndStopTimeAndOthers(String startTime, String stopTime, Integral integral) {
        List<Integral> integral_list = this.integralDao.listIntegralByStartTimeAndStopTimeAndOthers(startTime, stopTime, integral);
        return integral_list.size() == 0 ? null : integral_list;
    }

    @Transactional
    public void updateIntegral() {
        String date = DATEUtil.getNewDateYM();
        List<Integral> integral_list = this.integralDao.listIntegralNew();
        if (integral_list.size() != 0) {
            Iterator var3 = integral_list.iterator();

            while(var3.hasNext()) {
                Integral integral_list_i = (Integral)var3.next();
                int spaceTeamLoginNumber = 0;
                int spaceProjectNumber = 0;
                int spaceProjectDetailedNumber = 0;
                List<TeamMessage> teamMessage_list = this.teamMessageDao.listTeamMessageBySpaceMessageID(integral_list_i.getSpaceMessageID());
                int userNumber;
                int teamNumber;
                int spaceNumber;
                if (teamMessage_list.size() != 0) {
                    for(Iterator var9 = teamMessage_list.iterator(); var9.hasNext(); spaceProjectDetailedNumber += spaceNumber) {
                        TeamMessage teamMessage_list_i = (TeamMessage)var9.next();
                        userNumber = this.integralDao.getIntegralLoginByTeamMessageID(teamMessage_list_i.getTeamMessageID());
                        teamNumber = 0;
                        spaceNumber = 0;
                        String project_str = this.integralDao.getIntegralProjectByTeamMessageID(teamMessage_list_i.getTeamMessageID());
                        if (null != project_str) {
                            teamNumber = Integer.parseInt(project_str);
                        }

                        String projectDetailed_str = this.integralDao.getIntegralProjectDetailedByTeamMessageID(teamMessage_list_i.getTeamMessageID());
                        if (null != projectDetailed_str) {
                            spaceNumber = Integer.parseInt(projectDetailed_str);
                        }

                        spaceTeamLoginNumber += userNumber;
                        spaceProjectNumber += teamNumber;
                    }
                }

                integral_list_i.setTeamLogin(spaceTeamLoginNumber);
                integral_list_i.setProject(spaceProjectNumber);
                integral_list_i.setProjectDetailed(spaceProjectDetailedNumber);
                int spaceUserSitesNumber = 0;
                List<String> userSites_list = this.integralDao.getIntegralUserSitesBySpaceMessageID(integral_list_i.getSpaceMessageID());
                String userSites_list_i;
                if (userSites_list.size() != 0) {
                    for(Iterator var18 = userSites_list.iterator(); var18.hasNext(); spaceUserSitesNumber += Integer.parseInt(userSites_list_i)) {
                        userSites_list_i = (String)var18.next();
                    }
                }

                integral_list_i.setUserSites(spaceUserSitesNumber);
                userNumber = spaceUserSitesNumber;
                if (spaceUserSitesNumber > 300) {
                    userNumber = 300;
                }

                integral_list_i.setUserNumber(userNumber);
                teamNumber = spaceTeamLoginNumber + spaceProjectNumber + spaceProjectDetailedNumber;
                if (teamNumber > 300) {
                    teamNumber = 300;
                }

                integral_list_i.setTeamNumber(teamNumber);
                spaceNumber = integral_list_i.getExercise() + integral_list_i.getSpaceIndex() + integral_list_i.getEducationIndex() + integral_list_i.getMaterial() + integral_list_i.getSpaceLogin();
                if (spaceNumber > 400) {
                    spaceNumber = 400;
                }

                integral_list_i.setSpaceNumber(spaceNumber);
                int number = userNumber + teamNumber + spaceNumber;
                integral_list_i.setNumber(number);
                integral_list_i.setTime(date);
                List<Integral> integral_LastMonth_list_2 = this.integralDao.listIntegralByTimeAndspaceMessageID(date, integral_list_i.getSpaceMessageID());
                if (integral_LastMonth_list_2.size() != 0) {
                    this.integralDao.updateIntegral(integral_list_i);
                } else {
                    this.integralDao.saveIntegral(integral_list_i);
                }
            }
        }

    }

    @Transactional
    public String updateIntegralByUserTime(String time) {
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM");

        Date dateParse;
        try {
            dateParse = dateFormat.parse(time);
        } catch (ParseException var19) {
            var19.printStackTrace();
            return "日期格式出错";
        }

        String date = dateFormat.format(dateParse);
        List<Integral> integral_list = this.integralDao.listIntegralNewByUserTime(time);
        if (integral_list.size() != 0) {
            Iterator var6 = integral_list.iterator();

            while(var6.hasNext()) {
                Integral integral_list_i = (Integral)var6.next();
                int spaceTeamLoginNumber = 0;
                int spaceProjectNumber = 0;
                int spaceProjectDetailedNumber = 0;
                List<TeamMessage> teamMessage_list = this.teamMessageDao.listTeamMessageBySpaceMessageID(integral_list_i.getSpaceMessageID());
                int userNumber;
                int teamNumber;
                int spaceNumber;
                if (teamMessage_list.size() != 0) {
                    for(Iterator var12 = teamMessage_list.iterator(); var12.hasNext(); spaceProjectDetailedNumber += spaceNumber) {
                        TeamMessage teamMessage_list_i = (TeamMessage)var12.next();
                        userNumber = this.integralDao.getIntegralLoginByTeamMessageIDAndUserTime(teamMessage_list_i.getTeamMessageID(), time);
                        teamNumber = 0;
                        spaceNumber = 0;
                        String project_str = this.integralDao.getIntegralProjectByTeamMessageIDAndUserTime(teamMessage_list_i.getTeamMessageID(), time);
                        if (null != project_str) {
                            teamNumber = Integer.parseInt(project_str);
                        }

                        String projectDetailed_str = this.integralDao.getIntegralProjectDetailedByTeamMessageIDAndUserTime(teamMessage_list_i.getTeamMessageID(), time);
                        if (null != projectDetailed_str) {
                            spaceNumber = Integer.parseInt(projectDetailed_str);
                        }

                        spaceTeamLoginNumber += userNumber;
                        spaceProjectNumber += teamNumber;
                    }
                }

                integral_list_i.setTeamLogin(spaceTeamLoginNumber);
                integral_list_i.setProject(spaceProjectNumber);
                integral_list_i.setProjectDetailed(spaceProjectDetailedNumber);
                int spaceUserSitesNumber = 0;
                List<String> userSites_list = this.integralDao.getIntegralUserSitesBySpaceMessageIDAndUserTime(integral_list_i.getSpaceMessageID(), time);
                String userSites_list_i;
                if (userSites_list.size() != 0) {
                    for(Iterator var22 = userSites_list.iterator(); var22.hasNext(); spaceUserSitesNumber += Integer.parseInt(userSites_list_i)) {
                        userSites_list_i = (String)var22.next();
                    }
                }

                integral_list_i.setUserSites(spaceUserSitesNumber);
                userNumber = spaceUserSitesNumber;
                if (spaceUserSitesNumber > 300) {
                    userNumber = 300;
                }

                integral_list_i.setUserNumber(userNumber);
                teamNumber = spaceTeamLoginNumber + spaceProjectNumber + spaceProjectDetailedNumber;
                if (teamNumber > 300) {
                    teamNumber = 300;
                }

                integral_list_i.setTeamNumber(teamNumber);
                spaceNumber = integral_list_i.getExercise() + integral_list_i.getSpaceIndex() + integral_list_i.getEducationIndex() + integral_list_i.getMaterial() + integral_list_i.getSpaceLogin();
                if (spaceNumber > 400) {
                    spaceNumber = 400;
                }

                integral_list_i.setSpaceNumber(spaceNumber);
                int number = userNumber + teamNumber + spaceNumber;
                integral_list_i.setNumber(number);
                integral_list_i.setTime(date);
                List<Integral> integral_LastMonth_list_2 = this.integralDao.listIntegralByTimeAndspaceMessageID(date, integral_list_i.getSpaceMessageID());
                if (integral_LastMonth_list_2.size() != 0) {
                    this.integralDao.updateIntegral(integral_list_i);
                } else {
                    this.integralDao.saveIntegral(integral_list_i);
                }
            }
        }

        return "success";
    }
}
